// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from grbl_msgs:msg/State.idl
// generated code does not contain a copyright notice

#ifndef GRBL_MSGS__MSG__DETAIL__STATE__TRAITS_HPP_
#define GRBL_MSGS__MSG__DETAIL__STATE__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "grbl_msgs/msg/detail/state__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__traits.hpp"

namespace grbl_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const State & msg,
  std::ostream & out)
{
  out << "{";
  // member: header
  {
    out << "header: ";
    to_flow_style_yaml(msg.header, out);
    out << ", ";
  }

  // member: state_name
  {
    out << "state_name: ";
    rosidl_generator_traits::value_to_yaml(msg.state_name, out);
    out << ", ";
  }

  // member: state
  {
    out << "state: ";
    rosidl_generator_traits::value_to_yaml(msg.state, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const State & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: header
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "header:\n";
    to_block_style_yaml(msg.header, out, indentation + 2);
  }

  // member: state_name
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "state_name: ";
    rosidl_generator_traits::value_to_yaml(msg.state_name, out);
    out << "\n";
  }

  // member: state
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "state: ";
    rosidl_generator_traits::value_to_yaml(msg.state, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const State & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace grbl_msgs

namespace rosidl_generator_traits
{

[[deprecated("use grbl_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const grbl_msgs::msg::State & msg,
  std::ostream & out, size_t indentation = 0)
{
  grbl_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use grbl_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const grbl_msgs::msg::State & msg)
{
  return grbl_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<grbl_msgs::msg::State>()
{
  return "grbl_msgs::msg::State";
}

template<>
inline const char * name<grbl_msgs::msg::State>()
{
  return "grbl_msgs/msg/State";
}

template<>
struct has_fixed_size<grbl_msgs::msg::State>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<grbl_msgs::msg::State>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<grbl_msgs::msg::State>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // GRBL_MSGS__MSG__DETAIL__STATE__TRAITS_HPP_
